<template>
  <ele-modal
    :width="750"
    :visible="visible"
    :maskClosable="false"
    :title="title"
    :footer="null"
    :body-style="{ paddingBottom: '28px' }"
    @update:visible="updateVisible"
  >
    <ele-pro-table
      ref="tableRef"
      row-key="companyId"
      :datasource="datasource"
      :columns="columns"
      :customRow="customRow"
      :pagination="false"
    >
      <template #toolbar>
        <a-input-search
          allow-clear
          v-model:value="searchText"
          placeholder="请输入搜索关键词"
          style="width: 200px"
          @search="reload"
          @pressEnter="reload"
        />
      </template>
      <template #bodyCell="{ column, record }">
        <template v-if="column.key === 'companyLogo'">
          <a-image
            v-if="record.companyLogo"
            :src="FILE_THUMBNAIL + record.companyLogo"
            :preview="false"
            :width="45"
          />
        </template>
        <template v-if="column.key === 'companyType'">
          <a-tag v-if="record.companyType === 10">企业</a-tag>
          <a-tag v-if="record.companyType === 20">政府单位</a-tag>
        </template>
        <template v-if="column.key === 'action'">
          <a-space>
            <a-button type="link">选择</a-button>
          </a-space>
        </template>
      </template>
    </ele-pro-table>
  </ele-modal>
</template>

<script lang="ts" setup>
  import { ref } from 'vue';
  import {
    ColumnItem,
    DatasourceFunction
  } from 'ele-admin-pro/es/ele-pro-table/types';
  import { pageCompany } from '@/api/system/company';
  import { FILE_THUMBNAIL } from '@/config/setting';
  import { EleProTable } from 'ele-admin-pro';
  import { Company, CompanyParam } from '@/api/system/company/model';

  const props = defineProps<{
    // 弹窗是否打开
    visible: boolean;
    // 标题
    title?: string;
    // 企业类型
    companyType?: string;
    // 修改回显的数据
    data?: Company | null;
  }>();

  const emit = defineEmits<{
    (e: 'done', data: Company): void;
    (e: 'update:visible', visible: boolean): void;
  }>();

  /* 更新visible */
  const updateVisible = (value: boolean) => {
    emit('update:visible', value);
  };

  // 搜索内容
  const searchText = ref(null);

  // 表格实例
  const tableRef = ref<InstanceType<typeof EleProTable> | null>(null);

  // 表格配置
  const columns = ref<ColumnItem[]>([
    {
      title: '企业ID',
      dataIndex: 'tenantId'
    },
    {
      title: '企业名称',
      dataIndex: 'companyName'
    },
    {
      title: '企业类型',
      dataIndex: 'companyType',
      key: 'companyType'
    },
    {
      title: 'LOGO',
      dataIndex: 'companyLogo',
      key: 'companyLogo'
    },
    {
      title: '操作',
      key: 'action',
      align: 'center'
    }
  ]);

  // 表格数据源
  const datasource: DatasourceFunction = ({ page, limit, where, orders }) => {
    where = {};
    // 搜索条件
    if (searchText.value) {
      where.keywords = searchText.value;
    }
    if (props.companyType == 'empty') {
      where.emptyType = true;
    } else {
      where.companyType = props.companyType;
    }
    where.isStaff = true;
    return pageCompany({
      ...where,
      ...orders,
      page,
      limit
    });
  };

  /* 搜索 */
  const reload = (where?: CompanyParam) => {
    tableRef?.value?.reload({ page: 1, where });
  };

  /* 自定义行属性 */
  const customRow = (record: Company) => {
    return {
      // 行点击事件
      onClick: () => {
        updateVisible(false);
        emit('done', record);
      }
    };
  };
</script>
<style lang="less"></style>
